#include <string.h>
#include <iostream.h>
#include <stdlib.h>
#include <stddef.h>
#include "pol_dat.h"
#include "tctenar.h"
#include "konstant.h"

//kopirovaci konstruktor
TCtenar::TCtenar(TCtenar &stara)
{
  if((jmeno=new char[RETEZEC])==NULL){
    cerr<<"Malo pameti pro beh programu.";
    exit(0);
  }
  strcpy(jmeno,stara.dejJmeno());
  if(stara.dejAdresa()==NULL)
    adresa=NULL;
  else{
    if((adresa=new char[RETEZEC])==NULL){
      cerr<<"Malo pameti pro beh programu.";
      exit(0);
    }

    strcpy(adresa,stara.dejAdresa());
  }
  if(stara.dejRC()==NULL)
    RC=NULL;
  else{
    if((RC=new char[RETEZEC])==NULL){
      cerr<<"Malo pameti pro beh programu.";
      exit(0);
    }

    strcpy(RC,stara.dejRC());
  }
  id=stara.dejId();
}

//konstruktor
TCtenar::TCtenar(long int i, char *j, char *adr, char *rod){
  id=i;
  jmeno=j;
  adresa=adr;
  RC=rod;
}

//konstruktor bez parametru
TCtenar::TCtenar(){
  jmeno=NULL;
  adresa=NULL;
  RC=NULL;
  id=0L;
}

//destruktor
TCtenar::~TCtenar(){
  if(jmeno!=NULL)
    delete jmeno;
  if(adresa!=NULL)
    delete adresa;
  if(RC!=NULL)
    delete RC;
}
