#include <string.h>
#include <iostream.h>
#include <stdlib.h>
#include "konstant.h"
#include "pol_dat.h"
#include "ttitul.h"
#include "tkniha.h"


//kopirovaci konstruktor
TKniha::TKniha(TKniha &stara)
{
  if((isbn=new char[ISBN_ZNAKU])==NULL){
    cerr<<"Malo pameti"<<endl;
    exit(0);
  }
  if((nazev=new char[RETEZEC])==NULL){
    cerr<<"Malo pameti"<<endl;
    exit(0);
  }
  if((nakladatel=new char[RETEZEC])==NULL){
    cerr<<"Malo pameti"<<endl;
    exit(0);
  }
  strcpy(isbn,stara.dejIsbn());
  strcpy(nazev,stara.dejNazev());
  if(stara.dejNakladatel()!=NULL)
    strcpy(nakladatel,stara.dejNakladatel());
  else{
    delete nakladatel;
    nakladatel=NULL;
  }
  pocet_stran=stara.dejPocetStran();
  rok_vydani=stara.dejRok();
  id=stara.id;
}

//konstruktor bez parametru
TKniha::TKniha(){
  id=0L;
  isbn=NULL;
  nazev=NULL;
  nakladatel=NULL;
  pocet_stran=0;
  rok_vydani=0;
}

//konstruktor
TKniha::TKniha(long int ident,char *isb, char *n, int p, char *nak, int r){
  id=ident;
  isbn=isb;
  nazev=n;
  nakladatel=nak;
  rok_vydani=r;
  pocet_stran=p;
}

//destruktor
TKniha::~TKniha(){
  if(nazev!=NULL)
    delete nazev;
  if(isbn!=NULL)
    delete isbn;
  if(nakladatel!=NULL)
    delete nakladatel;
}
