class TPodrobnostiKniha:public TPodrobnosti{
  static const enum obsah_radku{RAD_JMENO,RAD_ISBN,RAD_NAKLAD,RAD_ROK,RAD_STRAN};
  static const enum chyby{ZMEN_ISBN,NUL_NAZEV,NUL_ISBN,EXIST_ISBN,SPATNE_ID,EXIST_ID};
  static const int ROK_ZNAKU;
  static const int STRAN_ZNAKU;
  TKniha *kniha;
  TNapsal **napsal;    //pole zaznamu o autorech titulu
  TKopie **kopie;      //pole zaznmu o kopiich titulu
  TDatabazeKniha *datkniha;  //vazba na databazi knih pro ukladani zmen
  TDatabazeNapsal *datnapsal;
  TDatabazeAutor *datautor;
  TDatabazeKopie *datkopie;
  int je_nova;        //indikator, zda se jedna o nacitani noveho zaznamu
  int pocet_kopii;
  int pocet_autoru;
  int posun(int);
  void utvorZaznam();
  int chyba(int druh);
  int smazat_autora();
  int novaKopie();
public:
TPodrobnostiKniha(TKniha *kni, TDatabazeKniha *dk,TDatabazeKopie *kop, TDatabazeNapsal *nap, TDatabazeAutor *aut);
int run();
int zmeny();

};
