#include <iostream.h>
#include <string.h>
#include <graphics.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include "konstant.h"
#include "tpole.h"
#include "tdatum.h"
#include "pol_dat.h"
#include "ttitul.h"
#include "tkniha.h"
#include "tkopie.h"
#include "tautor.h"
#include "tnapsal.h"
#include "tdatabaz.h"
#include "tdattitu.h"
#include "tdatknih.h"
#include "tdatkopi.h"
#include "tdatauto.h"
#include "tdatnaps.h"
#include "trozhran.h"
#include "tpodrobn.h"
#include "tpodkopi.h"



//ulozi texty na zobrazovani
void TPodrobnostiKopie::utvorZaznam(){
  int i;
  radku=0;
  TKniha *kniha;
  kniha=(TKniha *)kopie->dejTitul();
  nadpis[radku]="Prirustkove cislo: ";
  ltoa(kopie->dejPrirC(),text[radku],10);
  radku++;
  nadpis[radku]="Jmeno: ";
  strcpy(text[radku],kniha->dejNazev());
  radku++;
  nadpis[radku]="ISBN: ";
  strcpy(text[radku],kniha->dejIsbn());
  radku++;
  nadpis[radku]="Nakladatelstvi: ";
  strcpy(text[radku],kniha->dejNakladatel());
  radku++;
  nadpis[radku]="Rok vydani: ";
  itoa(kniha->dejRok(),text[radku],10);
  radku++;
  nadpis[radku]="Pocet stran: ";
  itoa(kniha->dejPocetStran(),text[radku],10);
  radku++;
  i=0;
  while(i<pocet_autoru)
  {
    if(radku==STD_POLOZEK)
      nadpis[radku]="Autori: ";
    else
      nadpis[radku]="        ";

    strcpy(text[radku],(napsal[i]->dejAutor())->dejJmeno());
    radku++;
    i++;
  }
}

//konstruktor
TPodrobnostiKopie::TPodrobnostiKopie(TKopie *kop,TDatabazeNapsal *nap){
  STD_POLOZEK = 6;
  kopie=kop;
  napsal=nap->dejPolozky((TKniha*)kopie->dejTitul(),&pocet_autoru);
  aktualni=0;
  pocatek=0;
  utvorZaznam();
  inicNapoveda(NENI_ZMENA);
}


//posune zobrazovanou cast textu
int TPodrobnostiKopie::posun(int kolik){
  int i;
  if(kolik==1)
  {
    if(aktualni<radku-1)
    {
       aktualni++;
       pocatek++;
       zobraz();
       return 1;
    }
    else
      return 0;
  }
  if(kolik==-1)
  {
    if(aktualni>0 && pocatek>0)
    {
      aktualni--;
      pocatek--;
      zobraz();
      return kolik;
    }
    else
      return 0;
  }
  return 0;
}

//ovladani
int TPodrobnostiKopie::run()
{
  char znak,rozsir;
  znak='\0';
  zobraz();
  napoveda();
  while(1)
  {
    while(!kbhit());
    znak=getch();
    if(znak=='\0')
    {
      rozsir=getch();

      switch(rozsir){
	case DOLU: if(aktualni-pocatek<RADKU-1 && aktualni<radku-1){
		    aktualni++;
		    zobraz();
		  }
		  else
		    posun(1);
		  break;
	case NAHORU:if(aktualni>pocatek){
		   aktualni--;
		   zobraz();
		 }
		 else
		   posun(-1);
		 break;
	case F10:exit(0);
		 break;

      }
    }
    else
      if(znak==ENTER) return 0;
  }
}
