#include <iostream.h>
#include <string.h>
#include <graphics.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include "konstant.h"
#include "tpole.h"
#include "tdatum.h"
#include "pol_dat.h"
#include "tctenar.h"
#include "ttitul.h"
#include "tkniha.h"
#include "tkopie.h"
#include "tautor.h"
#include "tnapsal.h"
#include "trezerva.h"
#include "tdatabaz.h"
#include "tdattitu.h"
#include "tdatknih.h"
#include "tdatkopi.h"
#include "tdatauto.h"
#include "tdatnaps.h"
#include "tdatcten.h"
#include "tdatreze.h"
#include "trozhran.h"
#include "tsezpolo.h"
#include "tsezknih.h"
#include "tpodrobn.h"
#include "tpodreze.h"


//zobrazi chybove hlasky
int TPodrobnostiRezervace::chyba(int druh)
{
  char znak;
  int y,vyska,navrat;
  clearviewport();
  y=LHY;
  setcolor(WHITE);
  vyska=2*textheight(" ");
  zrusNapoveda();
  if(druh==NEEXIST_ID){
    outtextxy(LHX,y,"Neexistuje ctenar z danym identifikacnim cislem.");
    y+=2*vyska;
    outtextxy(LHX,y,"Stiskni cokoliv.");
    while(!kbhit());
    getch();
    zobraz();
    napoveda();
    return -1;
  }
  if(druh==SPATNE_ID){
    outtextxy(LHX,y,"Identifikacni cislo bylo spatne zadano.");
    y+=2*vyska;
    outtextxy(LHX,y,"Stiskni cokoliv.");
    while(!kbhit());
    getch();
    zobraz();
    napoveda();
    return -1;
  }
  return 0;
}

//pomocna funkce pro zadavani nove polozky
int TPodrobnostiRezervace::novaRezervace(){
  char retezec[ID_ZNAKU];
  long int ident;
  TKniha *kniha;
  TCtenar* ctenar;
  clearviewport();
  aktualni=0;
  nadpis[aktualni]="Identifikacni cislo ctenare: ";
  retezec[0]='\0';
  inicNapoveda(ZMENA);
  napoveda();
  while(TRUE){
    outtextxy(LHX,LHY,nadpis[aktualni]);
    if(zadavani(retezec,ID_ZNAKU)==F1)
      return FALSE;
    if(sscanf(retezec,"%ld",&ident)!=1)
    {
      chyba(SPATNE_ID);
      continue;
    }
    else
      if((ctenar=datctenar->dejPolozku(ident))==NULL){
	chyba(NEEXIST_ID);
	continue;
      }
      else
	break;
  }
  TSeznamKniha seznam_knih(datkniha,datkopie,datnapsal,datautor);
  if((kniha=seznam_knih.vyber())!=NULL){
    delete rezervace;
    rezervace=new TRezervace(ctenar,kniha);
    if(rezervace==NULL){
      cerr<<"Malo pameti pro beh programu";
      exit(0);
    }
    datrezervace->pridatPolozku(rezervace);
    seznam_knih.~TSeznamKniha();
    return TRUE;
  }
  else{
    seznam_knih.~TSeznamKniha();
    return FALSE;
  }
}


//ulozi texty na zobrazovani
void TPodrobnostiRezervace::utvorZaznam(){
  int i;
  radku=0;
  if(je_nova==FALSE){
    nadpis[radku]="ID ctenare: ";
    itoa((rezervace->dejCtenar())->dejId(),text[radku],10);
    radku++;

    nadpis[radku]="Jmeno ctenare: ";
    strcpy(text[radku],(rezervace->dejCtenar())->dejJmeno());
    radku++;
    nadpis[radku]="Nazev titulu: ";
    strcpy(text[radku],(rezervace->dejTitul())->dejNazev());
    radku++;
    nadpis[radku]="Nakladatelstvi: ";
    strcpy(text[radku],(rezervace->dejTitul())->dejNakladatel());
    radku++;
    nadpis[radku]="Rok vydani: ";
    itoa((rezervace->dejTitul())->dejRok(),text[radku],10);
    radku++;
    i=0;
    while(i<pocet_autoru)
    {
      if(radku==STD_POLOZEK)
	nadpis[radku]="Autori: ";
      else
	nadpis[radku]="        ";

      strcpy(text[radku],(napsal[i]->dejAutor())->dejJmeno());
      radku++;
      i++;
    }
  }
}

//konstruktor
TPodrobnostiRezervace::TPodrobnostiRezervace(TRezervace *rez,
      TDatabazeNapsal *nap, TDatabazeCtenar *cten, TDatabazeKniha *knih,
      TDatabazeKopie *kop, TDatabazeAutor *aut,TDatabazeRezervace *datrez){

  STD_POLOZEK = 5;
  aktualni=0;
  pocatek=0;
  datctenar=cten;
  datnapsal=nap;
  datkniha=knih;
  datkopie=kop;
  datautor=aut;
  datrezervace=datrez;
  if(rez!=NULL){
    rezervace=rez;
    napsal=nap->dejPolozky((TKniha *)rezervace->dejTitul(),&pocet_autoru);
    je_nova=FALSE;
  }
  else{
    rezervace=new TRezervace;
    if(rezervace==NULL){
      cerr<<"Malo pameti pro beh programu";
      exit(0);
    }
    je_nova=TRUE;
  }
  utvorZaznam();
  inicNapoveda(NENI_ZMENA);
}


//posune zobrazovanou cast textu
int TPodrobnostiRezervace::posun(int kolik){
  int i;
  if(kolik==1)
  {
    if(aktualni<radku-1)
    {
       aktualni++;
       pocatek++;
       zobraz();
       return 1;
    }
    else
      return 0;
  }
  if(kolik==-1)
  {
    if(aktualni>0 && pocatek>0)
    {
      aktualni--;
      pocatek--;
      zobraz();
      return kolik;
    }
    else
      return 0;
  }
  return 0;
}

//ovladani
int TPodrobnostiRezervace::run()
{
  char znak,rozsir;
  znak='\0';
  zobraz();
  napoveda();
  if(je_nova==TRUE){
    if(novaRezervace()==FALSE)
      return FALSE;
    je_nova=FALSE;
    napsal=datnapsal->dejPolozky((TKniha *)rezervace->dejTitul(),&pocet_autoru);
    utvorZaznam();
    zobraz();
  }
  while(1)
  {
    while(!kbhit());
    znak=getch();
    if(znak=='\0')
    {
      rozsir=getch();

      switch(rozsir){
	case DOLU: if(aktualni-pocatek<RADKU-1 && aktualni<radku-1){
		    aktualni++;
		    zobraz();
		  }
		  else
		    posun(1);
		  break;
	case NAHORU:if(aktualni>pocatek){
		   aktualni--;
		   zobraz();
		 }
		 else
		   posun(-1);
		 break;
	case F10:exit(0);
		 break;

      }
    }
    else
      if(znak==ENTER)
	return 0;
  }
}

