#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <stdlib.h>
#include "konstant.h"
#include "tpole.h"
#include "pol_dat.h"
#include "ttitul.h"
#include "tkniha.h"
#include "tkopie.h"
#include "tautor.h"
#include "tnapsal.h"
#include "tdatabaz.h"
#include "tdattitu.h"
#include "tdatknih.h"
#include "tdatkopi.h"
#include "tdatauto.h"
#include "tdatnaps.h"
#include "trozhran.h"
#include "tsezpolo.h"
#include "tpodrobn.h"
#include "tpodkopi.h"
#include "tsezkopi.h"

const int TSeznamKopie::NAZEV_ZNAKU=65;

//inicializuje ukazatele na zobrazovane texty
void TSeznamKopie::utvorZaznam()
{
  int i,j,k;
  char *nazev;
  char *isb;

  for(i=0;i<pocet;i++)
  {
    ltoa(((TKopie *)zobrazeno[i])->dejPrirC(),text[i],10);
    for(k=strlen(text[i]);k<ID_ZNAKU;k++)
      text[i][k]=' ';
    nazev=(((TKopie *)zobrazeno[i])->dejTitul())->dejNazev();
    j=0;
    while(nazev[j]!='\0' && j<NAZEV_ZNAKU-1)
    {
      text[i][ID_ZNAKU+j]=nazev[j];
      j++;
    }
      text[i][ID_ZNAKU+j]='\0';
  }
  for(;i<RADKU;i++)
    text[i][0]='\0';
}


//zjisti polozky databaze pro zobrazeni
void TSeznamKopie::obnoveni(){
  int i;
  i=0;
  pocet=0;
  aktualni=0;
  databaze->zmenAktualni(-1L);
  do
  {
    zobrazeno[i]=(TKopie*)(((TDatabazeKopie *)databaze)->dejDalsi());
    i++;
    pocet++;
  }while(zobrazeno[i-1]!=NULL && i<RADKU);
  if(i!=RADKU) pocet--;
  databaze->zmenAktualni(0L);
}

//konstruktor
TSeznamKopie::TSeznamKopie(TDatabaze *dat, TDatabazeNapsal *nap)
{
  databaze=dat;
  napsal=nap;
//  vypujcka=vyp;
  nadpis="ID KOPIE  NAZEV";
  nadpis2="KOPIE";
  obnoveni();
  utvorZaznam();
  inicNapoveda(NENI_NOVA);
}


//posune zobrazovanou cast textu
int TSeznamKopie::posun(int kolik){
  TPolozkaDatabaze* novyrad;
  int i;

  switch(kolik){
    case -1:
       novyrad=(TKopie*)((TDatabazeKopie*)databaze)->dejPredchozi();
       if(novyrad==NULL) return 0;
       for(i=RADKU-1;i>0;i--)
	 zobrazeno[i]=zobrazeno[i-1];
       zobrazeno[0]=novyrad;
       utvorZaznam();
       zobraz();
       return -1;
    case 1:
       novyrad=(TKopie*)((TDatabazeKopie*)databaze)->dejDalsi();
       if(novyrad==NULL) return 0;
       for(i=0;i<RADKU-1;i++)
	 zobrazeno[i]=zobrazeno[i+1];
       zobrazeno[RADKU-1]=novyrad;
       utvorZaznam();
       zobraz();
       return 1;
    }
  return 0;
}

//ovladani
int TSeznamKopie::run()
{
  char znak,rozsir;
  znak='\0';
  zobraz();
  napoveda();
  while(TRUE)
  {
    while(!kbhit());
    znak=getch();
    if(znak=='\0')
    {
      rozsir=getch();

      switch(rozsir){
	case DELETE:
	    if(dotaz()==TRUE){
	      //vypujcka->ubratPolozkyKop((TKopie *)zobrazeno[aktualni]);
	      ((TDatabazeKopie *)databaze)->ubratPolozku((TKopie *)zobrazeno[aktualni]);
	      obnoveni();
	      utvorZaznam();
	      zobraz();
	    }
	    break;
	case DOLU: if(aktualni<pocet-1){
		    aktualni++;
		    databaze->posunAktualni(1L);
		    zobraz();
		  }
		  else
		    posun(1);
		  break;
	case NAHORU:if(aktualni>0){
		   aktualni--;
		   databaze->posunAktualni(-1L);
		   zobraz();
		 }
		 else
		   posun(-1);
		 break;
	case F10:exit(0);
		 break;
	case F2:databaze->ulozitDoSouboru();
		break;
	case F1:return 0;
      }
    }
    else
      if(znak==ENTER&&pocet>0)
      {
	TPodrobnostiKopie podrobnosti((TKopie *)zobrazeno[aktualni],napsal);
	podrobnosti.run();
	podrobnosti.~TPodrobnostiKopie();
	zobraz();
	napoveda();
      }
  }
}
