#include <iostream.h>
#include <string.h>
#include <graphics.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include "konstant.h"
#include "tpole.h"
#include "tdatum.h"
#include "pol_dat.h"
#include "tctenar.h"
#include "ttitul.h"
#include "tkniha.h"
#include "tkopie.h"
#include "tautor.h"
#include "tnapsal.h"
#include "tdatabaz.h"
#include "tdattitu.h"
#include "tdatknih.h"
#include "tdatkopi.h"
#include "tdatauto.h"
#include "tdatnaps.h"
#include "trozhran.h"
#include "tsezpolo.h"
#include "tsezauto.h"
#include "tpodrobn.h"
#include "tpodknih.h"


const int TPodrobnostiKniha::ROK_ZNAKU=4;
const int TPodrobnostiKniha::STRAN_ZNAKU=4;

//zadavani noveho zaznamu
int TPodrobnostiKniha::novaKopie(){
  char *retezec;
  char *stary_nadpis;
  long int ident;
  int stara_akt;
  char znak;
  retezec=new char[ID_ZNAKU];
  if(retezec==NULL){
    cerr<<"Malo pameti pro beh programu";
    exit(0);
  }
  inicNapoveda(ZMENA);
  napoveda();
  stary_nadpis=nadpis[aktualni];
  stara_akt=aktualni;
  aktualni=0;
  nadpis[aktualni]="Prirustkove cislo: ";
  sprintf(retezec,"%ld%c",datkopie->dejVolnePrir(),'\0');
  setcolor(GREEN);
  setcolor(RED);
  while(TRUE){
    clearviewport();
    outtextxy(LHX,LHY,nadpis[aktualni]);
    znak=zadavani(retezec,ID_ZNAKU);
    if(znak==F1){
      delete retezec;
      nadpis[aktualni]=stary_nadpis;
      aktualni=stara_akt;
      return FALSE;
    }
    else{
      if(sscanf(retezec,"%ld",&ident)!=1){
	chyba(SPATNE_ID);
	continue;
      }
      else{
	if(datkopie->dejPolozku(ident)!=NULL){
	  chyba(EXIST_ID);
	  continue;
	}
	else{
	  datkopie->pridatPolozku(new TKopie(ident,kniha));
	  break;
	}
      }
    }
  }
  delete retezec;
  aktualni=stara_akt;
  return TRUE;
}


//zobrazi chybove hlasky
int TPodrobnostiKniha::chyba(int druh)
{
  char znak;
  int y,vyska,navrat;
  clearviewport();
  y=LHY;
  setcolor(WHITE);
  vyska=2*textheight(" ");
  zrusNapoveda();
  if(druh==ZMEN_ISBN){
    outtextxy(LHX,y,"Bylo zmeneno ISBN. Prejete si i presto ulozit.");
    y+=2*vyska;
    outtextxy(LHX,y,"<A> - Ano        <N> - Ne        <P> - Pokracovat");
    while(TRUE){
      while(!kbhit());
      znak=getch();
      if(znak=='A' || znak=='a'){
	navrat=TRUE;
	break;}
      if(znak=='N' || znak=='n'){
	navrat=FALSE;
	break;}
      if(znak=='P' || znak=='p'){
	navrat=POKRACOVAT;
	break;}
    }
    zobraz();
    napoveda();
    return navrat;
  }
  if(druh==NUL_NAZEV){
    outtextxy(LHX,y,"Nazev musi byt nenulove delky.");
    y+=2*vyska;
    outtextxy(LHX,y,"Stiskni cokoliv.");
    while(!kbhit());
    getch();
    napoveda();
    zobraz();
    return -1;
  }
  if(druh==SPATNE_ID){
    outtextxy(LHX,y,"Prirustkove cislo bylo spatne zadano.");
    y+=2*vyska;
    outtextxy(LHX,y,"Stiskni cokoliv.");
    while(!kbhit());
    getch();
    napoveda();
    return -1;
  }
  if(druh==EXIST_ID){
    outtextxy(LHX,y,"Zadane prirostkove cislo je jiz prirazeno jine kopii.");
    y+=2*vyska;
    outtextxy(LHX,y,"Stiskni cokoliv.");
    while(!kbhit());
    getch();
    napoveda();
    return -1;
  }
  if(druh==NUL_ISBN){
    outtextxy(LHX,y,"Isbn musi byt nenulove delky.");
    y+=2*vyska;
    outtextxy(LHX,y,"Stiskni cokoliv.");
    while(!kbhit());
    getch();
    napoveda();
    zobraz();
    return -1;
  }
  if(druh==EXIST_ISBN){
    outtextxy(LHX,y,"Zadane ISBN jiz je prirazeno jine knize v databazi.");
    y+=2*vyska;
    outtextxy(LHX,y,"Stiskni cokoliv.");
    while(!kbhit());
    getch();
    napoveda();
    zobraz();
    return -1;
  }
  return 0;
}

//nacitani zmen v zaznamu a nacitani novych zaznamu
int TPodrobnostiKniha::zmeny(){
  char *retezec;
  char znak=1;
  char rozsir='\0';
  int prepis=TRUE;       //Zaznmenava, zda jde o prepis (TRUE) nebo pohyb
  int vysl_dotazu;
  int posledni_kl=0;                //Slouzi k zaznamenani posledni stisknute
  TKniha *nova;              //klavesy
  TKniha *stejna;
  nova=new TKniha(*kniha);
  if(nova==NULL){
    cerr<<"Nedostatek pameti pro beh programu";
    exit(0);
  }
  inicNapoveda(ZMENA);
  napoveda();
  while(1)
  {
    if(posledni_kl==DOLU || posledni_kl==NAHORU || posledni_kl==F2
       || posledni_kl==F1){
      znak='\0';          //Bylo-li posledni nacitani ukonceno jednou
      prepis=FALSE;   //z danych klaves je pokracovano jeji akci
    }
    else
      if(prepis==FALSE){    //Pokud je nastavena promenna prepis
			    //je primo zvolen rezim zmeny
	while(!kbhit());        //Nacteni z klavesnice
	znak=getch();
      }
    if(prepis==TRUE)          //Urci zda jde o nacitani
    {
      if(aktualni==RAD_JMENO){         //Podle aktualniho radku meni danou
	retezec=new char[RETEZEC];     //polozku zaznamu - nazev
	if(retezec==NULL){
	  cerr<<"Malo pameti pro beh programu";
	  exit(0);
	}
	strcpy(retezec,text[aktualni]);
	posledni_kl=zadavani(retezec,RETEZEC);
	strcpy(text[aktualni],retezec);
	nova->zmenNazev(retezec);
      }
      if(aktualni==RAD_NAKLAD){        //Zmena nakladatelstvi
	retezec=new char[RETEZEC];
	if(retezec==NULL){
	  cerr<<"Malo pameti pro beh programu";
	  exit(0);
	}
	strcpy(retezec,text[aktualni]);
	posledni_kl=zadavani(retezec,RETEZEC);
	strcpy(text[aktualni],retezec);
	nova->zmenNakladatel(retezec);
      }
      if(aktualni==RAD_ISBN){         //Zmena ISBN
	retezec=new char[ISBN_ZNAKU];
	if(retezec==NULL){
	  cerr<<"Malo pameti pro beh programu";
	  exit(0);
	}
	strcpy(retezec,text[aktualni]);
	posledni_kl=zadavani(retezec,ISBN_ZNAKU);
	strcpy(text[aktualni],retezec);
	nova->zmenIsbn(retezec);
      }
      if(aktualni==RAD_ROK){            //Zmena roku vydani
	int rok;
	retezec=new char[5];
	if(retezec==NULL){
	  cerr<<"Malo pameti pro beh programu";
	  exit(0);
	}
	strcpy(retezec,text[aktualni]);
	posledni_kl=zadavani(retezec,5);
	strcpy(text[aktualni],retezec);
	if(sscanf(retezec,"%d",&rok)==0)       //Neni-li rok zadan je 0
	  rok=0;
	delete retezec;
	nova->zmenRok(rok);
      }
      if(aktualni==RAD_STRAN){         //Zmena poctu stran
	int stran;
	retezec=new char[6];
	if(retezec==NULL){
	  cerr<<"Malo pameti pro beh programu";
	  exit(0);
	}
	strcpy(retezec,text[aktualni]);
	posledni_kl=zadavani(retezec,6);
	if(sscanf(retezec,"%d",&stran)==0)
	  stran=0;
	strcpy(text[aktualni],retezec);
	delete retezec;
	nova->zmenPocetStran(stran);
      }
      if(posledni_kl==1)
	posledni_kl=DOLU;             //retezec i do zobrazovaneho
    }                                    //pole
    else{                                //Nejde o nacitani
      if(znak=='\0')
      {
	if(posledni_kl==DOLU ||posledni_kl==NAHORU||posledni_kl==F2
	 ||posledni_kl==F1)
	  rozsir=posledni_kl;           //Priradi konkretni akci podle posledniho
	else                     //nacitani, nebo akci podle klavesnice nyni
	  rozsir=getch();
	if(rozsir==F1){           //Ukonceno bez ukladani
	  delete nova;
	  return FALSE;
	}
	if(rozsir==DOLU)        //Obsluha sipky dolu
	{
	  posledni_kl=0;
	  if(aktualni<STD_POLOZEK-1){
	    aktualni++;       //Pod atualnim radkem je zobrazen jeste jeden
	    zobraz();
	  }
	  if(aktualni<STD_POLOZEK)
	    prepis=TRUE;            //Pokud jde o jednu z polozek zaznamu
			 //knihy (tedy ne autor nebo kopie) bude zvolen
			 //rezim prepisu
	}
	if(rozsir==NAHORU){          //Obsluha sipky nahoru
	  posledni_kl=0;
	  if(aktualni>pocatek){
	    aktualni--;
	    zobraz();
	  }
	  else
	    if(pocatek!=0)
	      posun(-1);
	  if(aktualni<STD_POLOZEK)
	    prepis=TRUE;
	}
	if(rozsir==F2){        //Obsluha ukladani
	  posledni_kl=0;
	  if(je_nova==FALSE){       //Jde-li o zmenu stareho zaznamu
	    vysl_dotazu=dotaz();    //zepta se na pokracovani
	    if(vysl_dotazu==FALSE){     //Neukladat - znovu zobrazi puvodni
	      utvorZaznam();
	      zobraz();
	      delete nova;
	      break;
	    }
	    if(vysl_dotazu==POKRACOVAT){      //Pokracovat - dale rezim nacitani
	      prepis=TRUE;
	      continue;
	    }
	    if(vysl_dotazu==TRUE){     //Ulozit - kontrola nenulove delky
				    //nadpisu a zmeneneho ISBN
	      if(strlen(nova->dejNazev())!=0){
		if(strcmp(nova->dejIsbn(),kniha->dejIsbn())==0){
		  datkniha->zmenitPolozku(kniha,nova);
		  delete nova;
		  return TRUE;   //Provedl zmeny
		}
		else vysl_dotazu=chyba(ZMEN_ISBN);{
					     //Zobrazi chybu zmeneni ISBN
		  if(vysl_dotazu==TRUE){        //Uklada i zmenene ISBN
		    if(datkniha->existuje(nova->dejIsbn())!=NULL){
		      prepis=TRUE;           //Kontrola jednoznacnosti
		      chyba(EXIST_ISBN);      //ISBN v databazi
		      continue;
		    }
		    else{
		      datkniha->zmenitPolozku(kniha,nova);
		      delete nova;
		      return TRUE;
		    }
		  }
		  if(vysl_dotazu==FALSE)        //Neuklada, zobrazi puvodni
		  {
		    utvorZaznam();
		    zobraz();
		    delete nova;
		    break;
		  }
		  if(vysl_dotazu==POKRACOVAT){     //Pokracuje ve zmenach
		    prepis=TRUE;
		    continue;
		  }
		}
	      }
	      else{              //Delka nadpisu byla nulova
		prepis=TRUE;  //Zobrazi chybu a nasledne pokracuje v zadavani
		chyba(NUL_NAZEV);
		continue;
	      }
	    }
	  }
	  else{              //Jde-li o zadavani noveho zaznamu
	    if(strlen(nova->dejIsbn())==0){   //Kontrola delky ISBN
	      chyba(NUL_ISBN);
	      prepis=TRUE;
	      continue;
	    }
	    else{
	      if(strlen(nova->dejNazev())==0){  //Kontrola delky nazvu
		chyba(NUL_NAZEV);
		prepis=TRUE;
		continue;
	      }
	      else{
		if(datkniha->existuje(nova->dejIsbn())!=NULL){
		  prepis=TRUE;             //Kontrola jednoznacnosti ISBN
		  chyba(EXIST_ISBN);
		  continue;
		}
		else{
		  datkniha->pridatPolozku(nova); //Prida polozku do databaze
		  je_nova=FALSE;                 //knih
		  kniha=nova;
		  return TRUE;
		}
	      }
	    }
	  }
	}
	if(rozsir==F10)    //Ukonceni programu
	  exit(0);
      }
    }
  }
//  return FALSE;
  return TRUE;
}


//ulozi texty na zobrazovani
void TPodrobnostiKniha::utvorZaznam(){
  int i;
  radku=0;
  nadpis[radku]="Jmeno: ";
  strcpy(text[radku],kniha->dejNazev());
  radku++;
  nadpis[radku]="ISBN: ";
  strcpy(text[radku],kniha->dejIsbn());
  radku++;
  nadpis[radku]="Nakladatelstvi: ";
  strcpy(text[radku],kniha->dejNakladatel());
  radku++;
  nadpis[radku]="Rok vydani: ";
  if(kniha->dejRok()==0)
    text[radku][0]='\0';
  else
    itoa(kniha->dejRok(),text[radku],10);
  radku++;
  nadpis[radku]="Pocet stran: ";
  if(kniha->dejPocetStran()==0)
    text[radku][0]='\0';
  else
    itoa(kniha->dejPocetStran(),text[radku],10);
  radku++;
  i=0;
  while(i<pocet_autoru && i<30)
  {
    if(radku==STD_POLOZEK)
      nadpis[radku]="Autori: ";
    else
      nadpis[radku]="        ";

    strcpy(text[radku],(napsal[i]->dejAutor())->dejJmeno());
    radku++;
    i++;
  }
  i=0;
  while(i<pocet_kopii && i<30)
  {
    if(radku==STD_POLOZEK+pocet_autoru)
      nadpis[radku]="Prir. c. kopii: ";
    else
      nadpis[radku]="                ";

    ltoa(kopie[i]->dejPrirC(),text[radku],10);
    radku++;
    i++;
  }
}


TPodrobnostiKniha::TPodrobnostiKniha(TKniha *kni, TDatabazeKniha *dk,TDatabazeKopie *kop,TDatabazeNapsal *nap,TDatabazeAutor *aut){
  STD_POLOZEK = 5;
  aktualni=0;
  radku=0;
  pocatek=0;
  datkniha=dk;
  datnapsal=nap;
  datautor=aut;
  datkopie=kop;
  char *ptr;
  if(kni!=NULL){
    kniha=kni;
    je_nova=FALSE;
    napsal=nap->dejPolozky(kniha,&pocet_autoru);
    kopie=kop->dejPolozky(kniha,&pocet_kopii);
  }
  else
  {
    kniha=new TKniha;
    if(kniha==NULL){
      cerr<<"Malo pameti pro beh programu";
      exit(0);
    }
    je_nova=TRUE;
    kniha->zmenId(datkniha->dejVolneId());
    pocet_autoru=0;
    pocet_kopii=0;
    ptr=new char[RETEZEC];
    if(ptr==NULL){
      cerr<<"Malo pameti pro beh programu";
      exit(0);
    }
    ptr[0]='\0';
    kniha->zmenNazev(ptr);
    ptr=new char[RETEZEC];
    if(ptr==NULL){
      cerr<<"Malo pameti pro beh programu";
      exit(0);
    }
    ptr[0]='\0';
    kniha->zmenNakladatel(ptr);
    ptr=new char[RETEZEC];
    if(ptr==NULL){
      cerr<<"Malo pameti pro beh programu";
      exit(0);
    }
    ptr[0]='\0';
    kniha->zmenIsbn(ptr);
  }
  utvorZaznam();
  inicNapoveda();
  nap_text[5]="<DELETE> - odebrat vybraneho autora";
  nap_text[6]="<ALT+K> - pridat kopii                 <ALT+A> - pridat autora";
}



//Pomocna funkce ktera pri posunu mimo zobrazenou oblast urci dalsi radky
//Navratova hodnota pocet radku o ktere se podarilo oblast posunout
int TPodrobnostiKniha::posun(int kolik){
  int i;
  if(kolik==1)
  {
    if(aktualni<radku-1)
    {
       aktualni++;
       pocatek++;
       zobraz();
       return 1;
    }
    else
      return 0;
  }
  if(kolik==-1)
  {
    if(aktualni>0 && pocatek>0)
    {
      aktualni--;
      pocatek--;
      zobraz();
      return kolik;
    }
    else
      return 0;
  }
  return 0;
}


//ovladani
int TPodrobnostiKniha::run()
{
  char znak,rozsir;
  int poc_zmen=0;
  TAutor *aut;
  znak='\0';
  zobraz();
  napoveda();
  while(TRUE)
  {
    if(je_nova==FALSE)         //Pokud nejde o zadavani noveho zaznamu
    {                          //je nacitano ovladani z klavesnice
      while(!kbhit());
      znak=getch();
    }
    else
      znak='\0';            //Pro novy zaznam je volena rozsirena klavesa
    if(znak=='\0')
    {
      if(je_nova==FALSE)   //Nejde-li o novy zaznam nacita kod klavesy
	rozsir=getch();     //ze stdin
      else
      {
	rozsir=F4;        //Pro novy zaznam automaticky voli rezim
      }                  //zmen - tedy klavesu F4
      switch(rozsir){
	case DELETE:
	      if(smazat_autora()==TRUE)
		zobraz();
	      break;
	case ALT_A:
		  TSeznamAutor seznam_aut(datautor,datnapsal);
		  if((aut=seznam_aut.vyber())!=NULL){
		    datnapsal->pridatPolozku(new TNapsal(aut,kniha));
		    napsal=datnapsal->dejPolozky(kniha,&pocet_autoru);
		    utvorZaznam();
		  }
		  seznam_aut.~TSeznamAutor();
		  zobraz();
		  inicNapoveda();
		  napoveda();
		  break;
	case ALT_K: if(novaKopie()!=FALSE){
		      kopie=datkopie->dejPolozky(kniha,&pocet_kopii);
		      utvorZaznam();
		    }
		    zobraz();
		    inicNapoveda();
		    napoveda();
		    break;
	case DOLU: if(aktualni-pocatek<RADKU-1 && aktualni<radku-1)
		  {             //Ovladani posunu
		    aktualni++;
		    zobraz();
		  }
		  else
		    posun(1);    //Posun mimo zobrazenou oblast
		  break;
	case NAHORU:if(aktualni>pocatek)
		 {
		   aktualni--;
		   zobraz();
		 }
		 else
		   posun(-1);
		 break;
	case F4: if(aktualni<STD_POLOZEK){
		   if(zmeny()==FALSE)
		     return FALSE;
		   else
		     poc_zmen++;
		   inicNapoveda();
		   napoveda();
		 }
		 break;
	case F10:exit(0);
		 break;

      }
    }
    else
      if(znak==ENTER)
	if(poc_zmen>0)
	  return TRUE;     //Nebyly-li provadeny zmeny
	else
	  return FALSE;
  }
}


//pomocna funkce, ktera odstrani z databaze vybranou polozku
int TPodrobnostiKniha::smazat_autora()
{
  if(aktualni>=STD_POLOZEK && aktualni<STD_POLOZEK+pocet_autoru){
    datnapsal->ubratPolozku(napsal[aktualni-STD_POLOZEK]);
    for(int i=aktualni;i<radku-1;i++){
      strcpy(text[i],text[i+1]);
      nadpis[i]=nadpis[i+1];
      if(i<STD_POLOZEK+pocet_autoru)
	napsal[i-STD_POLOZEK]=napsal[i-STD_POLOZEK+1];
    }
    if(aktualni==radku-1)
      aktualni--;
    if(aktualni<pocatek)
      posun(-1);
    radku--;
    pocet_autoru--;
    if(pocet_autoru>0&&nadpis[STD_POLOZEK][0]==' ')
      nadpis[STD_POLOZEK]="Autori: ";
    return TRUE;
  }
  return FALSE;
}
