#include <string.h>
#include <graphics.h>
#include <stdio.h>
#include <conio.h>
#include "konstant.h"
#include "tpole.h"
#include "pol_dat.h"
#include "tdatabaz.h"
#include "trozhran.h"
#include "tpodrobn.h"

void TPodrobnosti::inicNapoveda(int druh){
  int g=0;
  if(druh!=ZMENA){
    nap_text[g++]="<F10> - konec programu";
    if(druh==JE_ZMENA)
      nap_text[g++]="<F4> - zmena zaznamu";
    nap_text[g++]="<SIPKA NAHORU> - pohyb nahoru";
    nap_text[g++]="<SIPKA DOLU> - pohyb dolu";
    nap_text[g++]="<ENTER> - zpet";
    for(;g<RADKU_NAPOVEDY;g++)
      nap_text[g]="";
  }
  else{
    nap_text[g++]="<F2> - ulozit zmeny";
    nap_text[g++]="<F1> - zrusit zmeny";
    nap_text[g++]="<SIPKY> - pohyb";
    nap_text[g++]="<ENTER> - presun na dalsi radek";
    nap_text[g++]="<HOME> - presun na zacatek radku    <END> - presun na konec radku";
    nap_text[g++]="<DELETE> - smazat aktualni znak     <BACKSPACE> - smazat znak pred aktualnim";
    for(;g<RADKU_NAPOVEDY;g++)
      nap_text[g]="";
  }
}


//do daneho retezce nacita znaky
int TPodrobnosti::zadavani(char *ret,int max_delka)
{
  int j,i=0;
  char znak='\0';
  char rozsir='\0';
  int akt_x, akt_y, x, delka;
  akt_x=x=LHX+strlen(nadpis[aktualni])*textwidth(" ");
  akt_y=LHY+(aktualni-pocatek)*textheight(" ")*2;
  delka=strlen(ret);
  setcolor(RED);
  outtextxy(akt_x,akt_y,ret);
  setcolor(WHITE);
  outtextxy(akt_x,akt_y+1,"_");
  setcolor(RED);
  while((int)znak != ENTER)
  {
    while(!kbhit());
    znak=getch();

    if(znak=='\0')
    {
      rozsir=getch();
      if(rozsir==DOLU||rozsir==NAHORU||rozsir==F2||rozsir==F1){
	ret[delka]='\0';
	setcolor(BLUE);
	outtextxy(akt_x,akt_y+1,"_");
	setcolor(WHITE);
	return rozsir;
      }
      if(rozsir==DELETE)
      {
	if(delka>0&&i<delka)
	{
	  setcolor(BLUE);
	  outtextxy(akt_x,akt_y,ret+i);
	  setcolor(RED);
	  for(j=i;j<=delka;j++)
	    ret[j]=ret[j+1];
	  outtextxy(akt_x,akt_y,ret+i);
	  delka--;
	}
      }
      if(rozsir==DOPRAVA&&i<delka)
      {
	setcolor(BLUE);
	outtextxy(akt_x,akt_y+1,"_");
	setcolor(WHITE);
	akt_x+=textwidth(" ");
	outtextxy(akt_x,akt_y+1,"_");
	setcolor(RED);
	i++;
      }
      if(rozsir==DOLEVA&&i>0)
      {
	setcolor(BLUE);
	outtextxy(akt_x,akt_y+1,"_");
	setcolor(WHITE);
	akt_x-=textwidth(" ");
	outtextxy(akt_x,akt_y+1,"_");
	setcolor(RED);
	i--;
      }
      if(rozsir==HOME&&i>0)
      {
	setcolor(BLUE);
	outtextxy(akt_x,akt_y+1,"_");
	setcolor(WHITE);
	akt_x=x;
	outtextxy(akt_x,akt_y+1,"_");
	setcolor(RED);
	i=0;
      }
      if(rozsir==END&&i<delka)
      {
	setcolor(BLUE);
	outtextxy(akt_x,akt_y+1,"_");
	setcolor(WHITE);
	akt_x=x+delka*textwidth(" ");
	outtextxy(akt_x,akt_y+1,"_");
	setcolor(RED);
	i=delka;
      }
      continue;
    }
    if((int)znak == ENTER)
    {
      setcolor(BLUE);
      outtextxy(akt_x,akt_y+1,"_");
      setcolor(RED);
      break;
    }
    if(znak == '\b')
    {
      if(i>0)
      {
	setcolor(BLUE);
	outtextxy(akt_x,akt_y+1,"_");
	akt_x-=textwidth(" ");
	outtextxy(akt_x,akt_y,ret+i-1);
	setcolor(RED);
	i--;
	for(j=i;j<=delka;j++)
	  ret[j]=ret[j+1];
	outtextxy(akt_x,akt_y,ret+i);
	setcolor(WHITE);
	outtextxy(akt_x,akt_y+1,"_");
	setcolor(RED);
	delka--;
      }
    }
    else
    {
      if(delka==max_delka-1)
	continue;
      setcolor(BLUE);
      outtextxy(akt_x,akt_y,ret+i);
      outtextxy(akt_x,akt_y+1,"_");
      setcolor(RED);
      for(j=delka;j>=i;j--)
	ret[j+1]=ret[j];
      ret[i]=znak;
      outtextxy(akt_x,akt_y,ret+i);
      akt_x+=textwidth(" ");
      setcolor(WHITE);
      outtextxy(akt_x,akt_y+1,"_");
      setcolor(RED);
      delka++;
      i++;
    }
  }
  ret[delka]='\0';
  return TRUE;
}



//zobrazi texty na obrazovku
void TPodrobnosti::zobraz(){
  int y=LHY;
  int velikost=textheight(" ")*2;
  clearviewport();
  for(int i=pocatek;i<RADKU+pocatek && i<radku;i++)
  {
    setcolor(GREEN);
    outtextxy(LHX,y,nadpis[i]);
    setcolor(WHITE);
    if(i==aktualni)
    {
      setcolor(RED);
      outtextxy(LHX+textwidth(nadpis[i]),y,text[i]);
      setcolor(WHITE);
    }
    else
      outtextxy(LHX+textwidth(nadpis[i]),y,text[i]);
    y+=velikost;
  }
}

//dotaz uzivateli, jestli se ma zaznam ulozit
int TPodrobnosti::dotaz()
{
  char znak;
  int y,vyska,navrat;
  clearviewport();
  zrusNapoveda();
  y=LHY;
  setcolor(WHITE);
  vyska=2*textheight(" ");
  outtextxy(LHX,y,"Ulozit zmeny");
  y+=2*vyska;
  outtextxy(LHX,y,"<A> - Ano        <N> - Ne        <P> - Pokracovat");
  while(1){
    while(!kbhit());
    znak=getch();
    if(znak=='A' || znak=='a'){
      navrat=TRUE;
      break;}
    if(znak=='N' || znak=='n'){
      navrat=FALSE;
      break;}
    if(znak=='P' || znak=='p'){
      navrat=POKRACOVAT;
      break;}
  }
  zobraz();
  napoveda();
  return navrat;
}

