#include <iostream.h>
#include <string.h>
#include <graphics.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include "konstant.h"
#include "tpole.h"
#include "tdatum.h"
#include "pol_dat.h"
#include "tctenar.h"
#include "ttitul.h"
#include "tkniha.h"
#include "tkopie.h"
#include "tautor.h"
#include "tnapsal.h"
#include "tvypujck.h"
#include "tdatabaz.h"
#include "tdattitu.h"
#include "tdatknih.h"
#include "tdatkopi.h"
#include "tdatauto.h"
#include "tdatnaps.h"
#include "tdatcten.h"
#include "tdatvypu.h"
#include "trozhran.h"
#include "tpodrobn.h"
#include "tpodvypu.h"



//zobrazi chybove hlasky
int TPodrobnostiVypujcka::chyba(int druh)
{
  char znak;
  int y,vyska,navrat;
  char *text;
  clearviewport();
  y=LHY;
  setcolor(WHITE);
  vyska=2*textheight(" ");
  zrusNapoveda();
  if(druh==NEEXIST_ID){
    text="Neexistuje ctenar s danym identifikacnim cislem.";
  }
  if(druh==SPATNE_ID){
    text="Identifikacni cislo bylo spatne zadano.";
  }
  if(druh==SPATNE_DATUM){
    text="Datum bylo spatne zadano.";
  }
  if(druh==NEEXIST_PRIR){
    text="Neexistuje kopie s danym prirustkovym cislem.";
  }
  if(druh==SPATNE_ID){
    text="Prirustkove cislo bylo spatne zadano.";
  }
  outtextxy(LHX,y,text);
  y+=2*vyska;
  outtextxy(LHX,y,"Stiskni cokoliv.");
  while(!kbhit());
  getch();
  zobraz();
  napoveda();
  return -1;
}


//pomocna funkce pro zadavani noveho zaznamu
int TPodrobnostiVypujcka::novaVypujcka(){
  char retezec[ID_ZNAKU];
  char retezec2[DATUM_ZNAKU];
  long int ident;
  int akt_y=LHY;
  int delka,i,den,mesic,rok;
  TDatum *dp,*dv;
  TCtenar* ctenar;
  TKopie* kopie;
  clearviewport();
  radku=1;
  pocatek=0;
  aktualni=0;
  nadpis[aktualni]="Identifikacni cislo ctenare: ";
  retezec[0]='\0';
  inicNapoveda(ZMENA);
  napoveda();
  while(TRUE){
    setcolor(GREEN);
    zobraz();
    setcolor(RED);
    if(zadavani(retezec,ID_ZNAKU)==F1)
      return FALSE;
    if(sscanf(retezec,"%ld",&ident)!=1)
    {
      chyba(SPATNE_ID);
      continue;
    }
    else
      if((ctenar=datctenar->dejPolozku(ident))==NULL){
	chyba(NEEXIST_ID);
	continue;
      }
      else{
	strcpy(text[aktualni],retezec);
	break;
      }
  }
  radku++;
  aktualni++;
  nadpis[aktualni]="Prirustkove cislo: ";
  retezec[0]='\0';
  akt_y+=2*textheight(" ");
  while(TRUE){
    setcolor(GREEN);
//    outtextxy(LHX,akt_y,nadpis[aktualni]);
    zobraz();
    setcolor(RED);
    if(zadavani(retezec,ID_ZNAKU)==F1)
      return FALSE;
    if(sscanf(retezec,"%ld",&ident)!=1)
    {
      chyba(SPATNE_PRIR);
      continue;
    }
    else
      if((kopie=datkopie->dejPolozku(ident))==NULL){
	chyba(NEEXIST_PRIR);
	continue;
      }
      else{
	strcpy(text[aktualni],retezec);
	break;
      }
  }
  radku++;
  aktualni++;
  nadpis[aktualni]="Datum pujceni: ";
  retezec2[0]='\0';
  akt_y+=2*textheight(" ");
  while(TRUE){
    setcolor(GREEN);
//    outtextxy(LHX,akt_y,nadpis[aktualni]);
    zobraz();
    setcolor(RED);
    if(zadavani(retezec2,DATUM_ZNAKU)==F1)
      return FALSE;
    strcpy(text[aktualni],retezec2);
    delka=strlen(retezec2);
    for(i=0;i<delka;i++){
     if(retezec2[i]<'0'||retezec2[i]>'9')
       retezec2[i]=' ';
    }
    if(sscanf(retezec2,"%d %d %d",&den,&mesic,&rok)!=3)
    {
      chyba(SPATNE_DATUM);
      continue;
    }
    else{
      dp=new TDatum(den,mesic,rok);
      if(dp==NULL){
	cerr<<"Malo pameti pro beh programu";
	exit(0);
      }
      break;
    }
  }

  aktualni++;
  radku++;
  nadpis[aktualni]="Datum vraceni: ";
  retezec2[0]='\0';
  akt_y+=2*textheight(" ");
  while(TRUE){
    setcolor(GREEN);
//    outtextxy(LHX,akt_y,nadpis[aktualni]);
    zobraz();
    setcolor(RED);
    if(zadavani(retezec2,DATUM_ZNAKU)==F1)
      return FALSE;
    strcpy(text[aktualni],retezec2);
    delka=strlen(retezec2);
    for(i=0;i<delka;i++){
     if(retezec2[i]<'0'||retezec2[i]>'9')
       retezec2[i]=' ';
    }
    if(sscanf(retezec2,"%d %d %d",&den,&mesic,&rok)!=3)
    {
      chyba(SPATNE_DATUM);
      continue;
    }
    else{
      dv=new TDatum(den,mesic,rok);
      if(dv==NULL){
	cerr<<"Malo pameti pro beh programu";
	exit(0);
      }
      break;
    }
  }
  vypujcka=new TVypujcka(ctenar,kopie,dp,dv);
  if(vypujcka==NULL){
    cerr<<"Malo pameti pro beh programu";
    exit(0);
  }
  datvypujcka->pridatPolozku(vypujcka);
  return TRUE;
}


//ulozi texty na zobrazovani
void TPodrobnostiVypujcka::utvorZaznam(){
  int i,k;
  radku=0;
  if(je_nova==FALSE){
    nadpis[radku]="Datum pujceni: ";
    itoa((vypujcka->dejDatumPujceni())->dejDen(),text[radku],10);
    k=strlen(text[radku]);
    text[radku][k]='.';
    k++;
    itoa((vypujcka->dejDatumPujceni())->dejMesic(),text[radku]+k,10);
    k=strlen(text[radku]);
    text[radku][k]='.';
    k++;
    itoa((vypujcka->dejDatumPujceni())->dejRok(),text[radku]+k,10);
    k=strlen(text[radku]);
    text[radku][k]='\0';
    radku++;


    nadpis[radku]="Pujceno do: ";
    itoa((vypujcka->dejDatumVraceni())->dejDen(),text[radku],10);
    k=strlen(text[radku]);
    text[radku][k]='.';
    k++;
    itoa((vypujcka->dejDatumVraceni())->dejMesic(),text[radku]+k,10);
    k=strlen(text[radku]);
    text[radku][k]='.';
    k++;
    itoa((vypujcka->dejDatumVraceni())->dejRok(),text[radku]+k,10);
    k=strlen(text[radku]);
    text[radku][k]='\0';
    radku++;

    nadpis[radku]="ID ctenare: ";
    ltoa((vypujcka->dejCtenar())->dejId(),text[radku],10);
    radku++;
    nadpis[radku]="Jmeno ctenare: ";
    strcpy(text[radku],(vypujcka->dejCtenar())->dejJmeno());
    radku++;
    nadpis[radku]="Prirustkove cislo: ";
    ltoa((vypujcka->dejKopie())->dejPrirC(),text[radku],10);
    radku++;
    nadpis[radku]="Nazev tiutlu: ";
    strcpy(text[radku],((vypujcka->dejKopie())->dejTitul())->dejNazev());
    radku++;
    nadpis[radku]="Nakladatelstvi: ";
    strcpy(text[radku],((vypujcka->dejKopie())->dejTitul())->dejNakladatel());
    radku++;
    nadpis[radku]="Rok vydani: ";
    itoa(((vypujcka->dejKopie())->dejTitul())->dejRok(),text[radku],10);
    radku++;
    i=0;
    while(i<pocet_autoru)
    {
      if(radku==STD_POLOZEK)
	nadpis[radku]="Autori: ";
      else
	nadpis[radku]="        ";

      strcpy(text[radku],(napsal[i]->dejAutor())->dejJmeno());
      radku++;
      i++;
    }
  }
}

//konstruktor
TPodrobnostiVypujcka::TPodrobnostiVypujcka(TVypujcka *vyp,
   TDatabazeNapsal *nap,TDatabazeCtenar *cten, TDatabazeKopie *kop,
   TDatabazeVypujcka *datvyp)
{
  STD_POLOZEK = 8;
  vypujcka=vyp;
  aktualni=0;
  pocatek=0;
  datnapsal=nap;
  datctenar=cten;
  datkopie=kop;
  datvypujcka=datvyp;
  if(vyp!=NULL){
    vypujcka=vyp;
    napsal=nap->dejPolozky((TKniha *)(vypujcka->dejKopie())->dejTitul(),&pocet_autoru);
    je_nova=FALSE;
  }
  else{
    vypujcka=new TVypujcka;
    if(vypujcka==NULL){
      cerr<<"Malo pameti pro beh programu";
      exit(0);
    }
    je_nova=TRUE;
  }
  utvorZaznam();
  inicNapoveda(NENI_ZMENA);
}


//posune zobrazovanou cast textu
int TPodrobnostiVypujcka::posun(int kolik){
  int i;
  if(kolik==1)
  {
    if(aktualni<radku-1)
    {
       aktualni++;
       pocatek++;
       zobraz();
       return 1;
    }
    else
      return 0;
  }
  if(kolik==-1)
  {
    if(aktualni>0 && pocatek>0)
    {
      aktualni--;
      pocatek--;
      zobraz();
      return kolik;
    }
    else
      return 0;
  }
  return 0;
}

//ovladani
int TPodrobnostiVypujcka::run()
{
  char znak,rozsir;
  znak='\0';
  int poc_zmen=0;
  zobraz();
  napoveda();
  if(je_nova==TRUE){
    if(novaVypujcka()==FALSE)
      return FALSE;
    else
      poc_zmen++;
    je_nova=FALSE;
    napsal=datnapsal->dejPolozky((TKniha *)(vypujcka->dejKopie())->dejTitul(),&pocet_autoru);
    utvorZaznam();
    zobraz();
  }
  while(1)
  {
    while(!kbhit());
    znak=getch();
    if(znak=='\0')
    {
      rozsir=getch();

      switch(rozsir){
	case DOLU: if(aktualni-pocatek<RADKU-1 && aktualni<radku-1){
		    aktualni++;
		    zobraz();
		  }
		  else
		    posun(1);
		  break;
	case NAHORU:if(aktualni>pocatek){
		   aktualni--;
		   zobraz();
		 }
		 else
		   posun(-1);
		 break;
	case F10:exit(0);
		 break;
      }
    }
    else
      if(znak==ENTER)
	if(poc_zmen>0)
	  return TRUE;
	else
	  return FALSE;
  }
}

