template <class T> class TPole
{ public:
  TPole(int n = 1);        // konstruktor
  TPole(TPole &Q);             // kopirovaci konstruktor
  ~TPole();                   // destruktor
  TPole& operator=(TPole &p);  // operator prirazeni
  T* operator[](int i); // operator zavorky
  int Delka() const;         // pristupova operace
  void prodluz(int kolik=PRODLOUZENI);
  void zkrat(int kolik=PRODLOUZENI);
  void uloz(T *prv,int poz);
  void ubrat(int index);

private:
  int delka;                 // aktualni delka dyn. pole
  T **p;                 // ukazatel do dyn. pameti
  void copy(const TPole &Q);
  void error(char *text);

};

