#include <graphics.h>
#include <stdio.h>
#include <stdlib.h>
#include "konstant.h"
#include "tpole.h"
#include "pol_dat.h"
#include "tdatabaz.h"
#include "trozhran.h"

void TRozhrani::zobraz(){
  clearviewport();
}

//inicializuje graficky mod obrazovky
int TRozhrani::inicGraf(){
  int gr_driver=DETECT,gmode,gerr,velikost,y;
  initgraph(&gr_driver,&gmode,BGI);
  if ( ( gerr=graphresult()) != grOk )
  {
    fprintf(stderr,"%s (%s)\n","Nelze inicializovat grafiku.\n",grapherrormsg(gerr));
    exit (FALSE);
  }
  else
  {
    velikost=2*textheight(" ");
    y=LHY+(RADKU+2)*velikost;
    setviewport(0,0,getmaxx(),y,1);
    settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
    settextjustify(LEFT_TEXT,CENTER_TEXT);
    setcolor(WHITE);
    setbkcolor(BLUE);
  }
  return TRUE;
}


//void zobrazi napovedu k ovladani
void TRozhrani::napoveda(){
  int y,velikost,col;
  col=getcolor();
  setcolor(GREEN);
  velikost=2*textheight(" ");
  y=LHY+(RADKU+2)*velikost;
  setviewport(0,y,getmaxx(),getmaxy(),1);
  clearviewport();
  y=LHY;
  for(int i=0;i<RADKU_NAPOVEDY;i++){
    outtextxy(LHX,y,nap_text[i]);
    y+=velikost;
  }
  setcolor(col);
  y=LHY+(RADKU+2)*velikost;
  setviewport(0,0,getmaxx(),y,1);
}

void TRozhrani::zrusNapoveda(){
  int y,velikost;
  velikost=2*textheight(" ");
  y=LHY+(RADKU+2)*velikost;
  setviewport(0,y,getmaxx(),getmaxy(),1);
  clearviewport();
  y=LHY+(RADKU+2)*velikost;
  setviewport(0,0,getmaxx(),y,1);
}